/*****************************************************************************/
/* jpcLinks.h                                                                */
/* Joe Christy	3/30/91                                                      */
/*****************************************************************************/
/*                                                                           */
/*    Copyright (C) 1991  Joe Christy                                        */
/*                                                                           */
/*    This program is free software; you can redistribute it and/or modify   */
/*    it under the terms of the GNU General Public License as published by   */
/*    the Free Software Foundation; either version 1, or (at your option)    */
/*    any later version.                                                     */
/*                                                                           */
/*    This program is distributed in the hope that it will be useful,        */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of         */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          */
/*    GNU General Public License for more details.                           */
/*                                                                           */
/*    You should have received a copy of the GNU General Public License      */
/*    along with this program; if not, write to the Free Software            */
/*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.              */
/*                                                                           */
/*****************************************************************************/

#include "link_projection.h"

/*****************************************************************************/
/* Here are some tyepdefs for Mac backwards compatability                    */
/*****************************************************************************/
typedef struct Pt {
	int             v;
	int             h;
} Point;

typedef struct Rct {
	int             top;
	int             left;
	int             bottom;
	int             right;
} Rect;
/*****************************************************************************/
/* Here are some tyepdefs from snappea's link_entry.c which we need          */
/*****************************************************************************/
/* Some are juiced up for tanglewise link entry JPC 1/19/91                  */
/*****************************************************************************/
enum {
	over = 0,
	under
};

typedef struct cmpt {				   /* added buoy JPC 1/16/91 */
	struct ed      *anchor,
	               *buoy;			   /* what's on the opposite end from an
									    * anchor? */
	struct cmpt    *next;
} component;

typedef struct ed {					   /* added finish, prev JPC 1/16/91 */
	Point           start,
	                finish;
	struct crsg    *crossing_list;
	struct ed      *next,
	               *prev;
	/* for use in putLink() */
	int             index;
} edge;

typedef struct crsg {				   /* added prev JPC 1/19/91 */
	int             dist;			   /* distance from start in city block
									    * metric */
	int             over_or_under;
	int             r_or_l;
	struct ed      *other_edge;
	struct crsg    *next,
	               *prev;
	/* for use in doSaveMfld() and, in 2n+1 form, in putLink() */
	int             index0;
	/* for use in doAlternate() */
	struct crsg    *next_cr;		   /* next "struct crsg" on link	 */
	struct c_l     *location;		   /* this crossing's location		 */
} crossing;

typedef struct c_l {
	Rect            square;
	edge           *overstrand,
	               *understrand;
	struct crsg    *overcrossing,
	               *undercrossing;
	struct c_l     *next;
	/* for use in doAlternate() */
	int             visited;		   /* has this "struct crsg" been
									    * visited?	 */
} crossing_location;

